# Precondition
Needs curl installed
```
sudo apt install curl
```
## Predondition for FlexCard PMC-II
Needs yafu installed
```
sudo apt install ./yafu_*_amd64.deb
```

# Examples
Flash FPGA on PCIe3/PXie3
```
./yafu_ng -file=example.fpga
```
Flash CPU on PCIe3/PXie3
```
./yafu_ng -file=example.s19
```
Flash CPU on second PCIe3/PXie3
```
./yafu_ng -file=example.s19 -host=127.0.2.1
```
Flash CPU on FlexDevice L
```
./yafu_ng -file=example.s19 -host=192.168.1.15
```
Flash FPGA on PMC-II (Administrator rights are required)
```
sudo ./yafu_ng -file=example.fwf
```

# Flashing without yafu\_ng
## curl
Needs curl installed
```
sudo apt install curl
```
E.g. flash FPGA
```
curl --tftp-blksize 32768 -T 3-00950A01_application_0x00E0_0_0_3_7.fpga tftp://127.0.1.1/fpga/application
```

## tftp-hpa
Should not be used because blocksize can not be entered so flashing is slow.  
Needs tftp-hpa installed
```
sudo apt install tftp-hpa
```
e.g. flash CPU
```
tftp -v -m binary 127.0.1.1 -c put Image.s19 "cpu/application"
```
